/*

Writing cutscenes

function Scene()
{
	PersonMove(0, "u1 d1 l1 r1 w20 /");
	PersonMove("peasant", "i<crying> a80");
	
	WaitForPeople();
	
	PersonMove("knight", "s1 z3 w20 e u1");
}

Command list:
uN - move up N tiles [x]
dN - move down N tiles [x]
lN - move left N tiles [x]
rN - move right N tiles [x]
oN - move random direction N tiles [x]
wN - wait N time [x]
i<S> - change direction to S, < is used to indicate beginning of S, > the ending [x]
aN - animate without moving for N [x]
zN - switch to frame N [x]
sN - set walk speed to N [x]
e - restore sprite to normal walking after using a and/or z [x]
/ - repeat move list [x]
xN - set person's X to N
yN - set person's Y to N

*/



/////////////////////////////////////////////////////////////////////////////////////////

function PersonMove(p, code)
{
	if ( typeof( p ) == "string")
		{
			n = PersonNameToNumber(p)
			Person[n].MoveCode.setCode(code);
		}
	
	if ( typeof( p ) == "number")
		{
			Person[p].MoveCode.setCode(code);
		}		
}

/////////////////////////////////////////////////////////////////////////////////////////

function oMoveCode()
{
	this.speed = 2;
	this.code = ""
	this.position = 0
	this.value = 0
	
	this.move_direction = 0
	this.direction = -1;
	this.frame = -1;
	
	this.done = true
	this.loop = false
	
	this.suspend
	
	this.setCode = SetCode
	this.Update = MoveCodeUpdate
	
}

/////////////////////////////////////////////////////////////////////////////////////////

function SetCode(code)
{
	this.code = code;
	this.position = 0;
	this.value = 0;
	this.done = false
}

/////////////////////////////////////////////////////////////////////////////////////////

function MoveCodeUpdate(person)
{
	/////////////////////////////////////////////////////////////////////////////////////////

	if (this.code == "" || this.position > this.code.length-1)
			{
				this.done = true;
				this.loop = false
				this.frame = -1
				this.direction = -1
				
				if (this.suspend == true) { SuspendPlayer = false; this.suspend = false; }
			
				return
			}
			
	if (this.position == 0)
		{
			for (var i = 0; i < this.code.length; i++)
				{
					if (this.code[i] == "/") this.loop = true;
				}
		}
		
	for (var i = 0; i < Player.length; i++)
		{
			if (Player[i].name == person.name) { SuspendPlayer = true; this.suspend = true; }
		}
			
	this.done = false;
			
	/////////////////////////////////////////////////////////////////////////////////////////
	
	if (this.frame != -1)
		{
			SetPersonFrame(person.name, this.frame)
		}
		
	/////////////////////////////////////////////////////////////////////////////////////////
		
	if (this.direction != -1)
		{
			SetPersonDirection(person.name, this.direction)
		}		
		
	/////////////////////////////////////////////////////////////////////////////////////////
	
	switch ( this.code[this.position].toUpperCase() )
		{
			/////////////////////////////////////////////////////////////////////////////////////////
			//MOVE UP N TILES
			/////////////////////////////////////////////////////////////////////////////////////////
		
			case "U":
			
				//Log("U")
				person.yv = -this.speed
				this.value += this.speed
				if (this.value >= GetCodeValue(this)*GetTileHeight()) IncreaseToNextCommand(this)
				
			break;
			
			/////////////////////////////////////////////////////////////////////////////////////////
			//MOVE DOWN N TILES
			/////////////////////////////////////////////////////////////////////////////////////////
			
			case "D":
			
				//Log("D")
				person.yv = this.speed
				this.value += this.speed
				if (this.value >= GetCodeValue(this)*GetTileHeight()) IncreaseToNextCommand(this)
				
			break;
			
			/////////////////////////////////////////////////////////////////////////////////////////
			//MOVE LEFT N TILES
			/////////////////////////////////////////////////////////////////////////////////////////
				
			case "L":
			
				//Log("L")
				person.xv = -this.speed
				this.value += this.speed
				if (this.value >= GetCodeValue(this)*GetTileWidth()) IncreaseToNextCommand(this)
				
			break;
			
			/////////////////////////////////////////////////////////////////////////////////////////
			//MOVE RIGHT N TILES
			/////////////////////////////////////////////////////////////////////////////////////////
				
			case "R":
			
				//Log("R")
				person.xv = this.speed
				this.value += this.speed
				if (this.value >= GetCodeValue(this)*GetTileWidth()) IncreaseToNextCommand(this)		
				
			break; 
			
			/////////////////////////////////////////////////////////////////////////////////////////
			//REPEAT
			/////////////////////////////////////////////////////////////////////////////////////////
			
			case "/":
			
				//Log("repeat");
				this.loop = true;
				this.position = 0;
				
			break; 
			
			/////////////////////////////////////////////////////////////////////////////////////////
			//WAIT N TIME
			/////////////////////////////////////////////////////////////////////////////////////////
			
			case "W":
			
				//Log("wait");
				this.xv = 0;
				this.yv = 0;
				
				this.value += 1
				if ( this.value >= GetCodeValue(this) ) IncreaseToNextCommand(this)				
				
			break;
			
			/////////////////////////////////////////////////////////////////////////////////////////
			//MOVE RANDOM DIRECTION N TILES
			/////////////////////////////////////////////////////////////////////////////////////////
			
		  case "O":
		  
				//Log("random")
				if (this.value == 0) this.move_direction = Random(0,3)
				switch (this.move_direction)
					{
						case 0:
							person.yv = -this.speed
						break; case 1:
							person.yv = this.speed
						break; case 2:
							person.xv = -this.speed
						break; case 3:
							person.xv = this.speed
						break;
					}

				
				this.value += this.speed
				if (this.value >= GetCodeValue(this)*GetTileWidth()) IncreaseToNextCommand(this)	
						
			break; 
			
			/////////////////////////////////////////////////////////////////////////////////////////
			//SET SPEED TO N
			/////////////////////////////////////////////////////////////////////////////////////////
			
			case "S":
			
				//Log("speed")
				this.speed = GetCodeValue(this)
				IncreaseToNextCommand(this)	
				
			break;
			
			/////////////////////////////////////////////////////////////////////////////////////////
			//ANIMATE FOR N TIME
			/////////////////////////////////////////////////////////////////////////////////////////
			
			case "A":
			
				//Log("animate")
				this.xv = 0;
				this.yv = 0;
				
				QueuePersonCommand(person.name,COMMAND_ANIMATE,true)
				
				this.value += 1
				if ( this.value >= GetCodeValue(this) ) IncreaseToNextCommand(this)		
				
			break;			
			
			/////////////////////////////////////////////////////////////////////////////////////////
			//SET PERSON FRAME
			/////////////////////////////////////////////////////////////////////////////////////////
				
			case "Z":
			
				//Log("frame")
				this.frame = GetCodeValue(this)
				
				IncreaseToNextCommand(this)		
				
			break;				

			/////////////////////////////////////////////////////////////////////////////////////////			
			//RESTORE PERSON FRAME/DIRECTION
			/////////////////////////////////////////////////////////////////////////////////////////	

			case "E":
			
				//Log("restore")
				this.frame = -1
				this.direction = -1
				
				IncreaseToNextCommand(this)		
				
			break;
				
			/////////////////////////////////////////////////////////////////////////////////////////			
			//SET PERSON DIRECTION
			/////////////////////////////////////////////////////////////////////////////////////////
								
			case "I":
			
				//Log("direction")
				this.direction = GetCodeString(this)
				
				IncreaseToNextCommand(this)	
				
			break;		
			
			/////////////////////////////////////////////////////////////////////////////////////////			
			//SET PERSON X
			/////////////////////////////////////////////////////////////////////////////////////////
								
			case "X":
			
				//Log("x")
				SetPersonX(person.name,GetCodeValue(this));
				
				IncreaseToNextCommand(this)	
				
			break;		
			
			/////////////////////////////////////////////////////////////////////////////////////////			
			//SET PERSON Y
			/////////////////////////////////////////////////////////////////////////////////////////
								
			case "Y":
			
				//Log("y")
				SetPersonY(person.name,GetCodeValue(this));
				
				IncreaseToNextCommand(this)	
				
			break;									
		
		}

}

/////////////////////////////////////////////////////////////////////////////////////////

function GetCodeValue(obj)
{
	n = ['0','1','2','3','4','5','6','7','8','9','.']

	p = obj.position+1;
	value = ""
	while ( IsInArray(obj.code[p],n) ) { value = value+obj.code[p]; p++; }
	
	return Number(value)
}

/////////////////////////////////////////////////////////////////////////////////////////

function GetCodeString(obj)
{

	p = obj.position+1;

	while ( obj.code[p] != "<" ) { p++; }
	
	p++

	value = ""
	
	while ( obj.code[p] != ">" ) { value = value+obj.code[p]; p++; }
	
	return value
}

/////////////////////////////////////////////////////////////////////////////////////////

function IncreaseToNextCommand(obj)
{
	n = ['0','1','2','3','4','5','6','7','8','9','.',' ','<','>']

	p = obj.position+1;
	
	InString = false;

	while ( IsInArray(obj.code[p],n) || InString == true ) 
		{
			if (obj.code[p] == "<") InString = true; 
			if (obj.code[p] == ">") InString = false; 
			p++;
		}
	
	obj.value = 0;
	
	obj.position = p
}

/////////////////////////////////////////////////////////////////////////////////////////

function IsInArray(v,arr)
{
	for (var i = 0; i < arr.length; i++)
		{
			if (arr[i] == v) return true;
		}
	return false
}

/////////////////////////////////////////////////////////////////////////////////////////

function WaitForMove()
{
	NextUpdate = GetTime()+UpdateRate;

	PeopleMoving = true

	while (PeopleMoving)
		{
			p = 0
		
			for (var i = 0; i < Person.length; i++)
				{
					if (Person[i].MoveCode.done == true && Person[i].MoveCode.loop == false) p++;
					if (Person[i].MoveCode.loop == true) p++
				}
				
			if (p >= Person.length) PeopleMoving = false;
			
			po = p
		
			RenderMap()
			RenderProcess_Manager_Run()
			
			if (NextUpdate < GetTime())
				{
					UpdateProcess_Manager_Run()
					UpdateMapEngine()
					
					NextUpdate = GetTime()+UpdateRate;
				}
			
			FlipScreen();
		}
}
