

/////////////////////////////////////////////////////////////////////////////////////////
//GLOBAL VARIABLES
/////////////////////////////////////////////////////////////////////////////////////////

Person = new Array()
Player = new Array()

SuspendPlayer = false;
UpdateRate = 11

const State_Walk = 0
const State_Attack = 1
const State_Recover = 2

const Type_Player = 0
const Type_Enemy = 1

const Character_Thomas = 0;
const Character_Keli = 1;

/////////////////////////////////////////////////////////////////////////////////////////
//EVALUATE THE GAME'S SCRIPTS
/////////////////////////////////////////////////////////////////////////////////////////

EvaluateScript("log.js")
EvaluateScript("managers.js")
EvaluateScript("game.js")
EvaluateScript("weapons.js")
EvaluateScript("cutscene.js")
EvaluateScript("windows.js")
EvaluateScript("textbox.js")
EvaluateScript("bar.js")
EvaluateScript("particle.js")
EvaluateScript("people.js")
EvaluateScript("people_creates.js")
EvaluateScript("data.js")
EvaluateScript("misc.js")

/////////////////////////////////////////////////////////////////////////////////////////
//GAME() - FUNCTION USED WHEN STARTING THE GAME
/////////////////////////////////////////////////////////////////////////////////////////

function game()
{

	Log("Starting game")
	
	GameInitilization();
	
	InitBars();
				
	UProcList.push(ProcessPeople)
	UProcList.push(WindowDisplayUpdate)
	UProcList.push(UpdateBars)
	UProcList.push(UpdateParticles)
	UProcList.push(UpdateMusic)
	
	RProcList.push(WindowDisplayRender)
	RProcList.push(RenderBars)
	RProcList.push(RenderParticles)
								
	MapEngine("title.rmp", 60);

}

function TestSpawn()
{
	SpawnPlayer(  "hero","hero.rss",2,173,
								KEY_UP,KEY_DOWN,KEY_LEFT,KEY_RIGHT,
								KEY_Z,KEY_X,KEY_C, PlayerInput);
								
	//TextBox(6)
								
	/*SpawnPlayer(  "hero2","hero.rss",55,25,
								KEY_W,KEY_S,KEY_A,KEY_D,
								KEY_X,KEY_S, PlayerInput);*/
								
	//SpawnPerson("Enemy", "hero.rss", 85, 125, eTestEnemyHurt, eTestEnemyTouch, eTestEnemyUpdate, eTestEnemyTalk)
	
	//SpawnPerson("NPC", "hero.rss", 145, 155, eTestNPCHurt, eTestNPCTouch, eTestNPCUpdate, eTestNPCTalk)
	
	//SpawnPerson("Enemy2", "hero.rss", 45, 225, eTestEnemyHurt, eTestEnemyTouch, eTestEnemyUpdate, eTestEnemyTalk)
}

/////////////////////////////////////////////////////////////////////////////////////////

function SpawnPerson(name, sprite, x, y, Hurt, Touch, Update, Talk) //Create a person
{
	Log("Creating person: "+name);
	
	CreatePerson(name, sprite, true)

	p = new oPerson(name, Hurt, Touch, Update, Talk);
	
	SetPersonX(name,x)
	SetPersonY(name,y)

	Person.push( p );
}

/////////////////////////////////////////////////////////////////////////////////////////

function SpawnPlayer(name, sprite, x, y, u, d, l, r, a, b, c, onUpdate) //Create a player
{
	Log("Creating player: "+name);

	SpawnPerson(name, sprite, x, y, ePlayerHurt, ePlayerTouch, ePlayerUpdate, ePlayerTalk); //Spawn player's person
	
	Person[Person.length-1].type = Type_Player
	
	AttachCamera(name); //Attach the camera to the player
	
	Player.push( new oPlayer(name, sprite, u, d, l, r, a, b, c, onUpdate) ); //Add player to the player listing
	
	AttachCamera(Player[0].name)
}

/////////////////////////////////////////////////////////////////////////////////////////

function oPerson(name,Hurt,Touch,Update,Talk)
{

	if ( PersonExists(name) ) SetPersonFrameRevert(name, 2)

	/////////////////////////////////////////////////////////////////////////////////////////
	//NAME AND X/Y VELOCITY VARIABLES
	/////////////////////////////////////////////////////////////////////////////////////////

	this.name = name //PERSON NAME
	this.weapon = 0
	
	this.xv = 0 // X VELOCITY
	this.yv = 0 // Y VELOCITY
	
	/////////////////////////////////////////////////////////////////////////////////////////
	//PERSON ON HURT/TOUCH/UPDATES
	/////////////////////////////////////////////////////////////////////////////////////////
	
	this.onHurt = Hurt // Used for when the person is succesfully attacked by another person
	this.onTouch = Touch // Used for when the person is touched by another person
	this.onUpdate = Update //Is ran every game update, used for AI and the like
	this.onTalk = Talk
	
	/////////////////////////////////////////////////////////////////////////////////////////
	//PERSON STATES
	/////////////////////////////////////////////////////////////////////////////////////////
	
	this.state = State_Walk
	this.state_frame = 0
	
	/////////////////////////////////////////////////////////////////////////////////////////
	
	//this.Attack_Length = 40 //Number of updates to have the wepaon out
	
	/////////////////////////////////////////////////////////////////////////////////////////

	this.atk = 3
	this.def = 2
	this.spd = 2
	
	this.lvl = 1
	this.xp = 0
	
	this.gold = 0
	
	/////////////////////////////////////////////////////////////////////////////////////////

	this.mhp = -1
	this.getMaxHP = function()
											{
												if (this.mhp == -1) return Math.floor( ( (this.lvl * 1.5)+(this.atk / 2)+(this.def) ) )
												else { return this.mhp }
											}		
	this.hp = this.getMaxHP()

											
	/////////////////////////////////////////////////////////////////////////////////////////										
	
	this.invincible = false
	this.invincible_timer = 0;
	
	this.talk = false;
	
	/////////////////////////////////////////////////////////////////////////////////////////
	//FUNCTIONS RELATED TO ATTACKING
	/////////////////////////////////////////////////////////////////////////////////////////
	
	this.Recover = function ()
												{
													if (this.state_frame >= Weapon[this.weapon].recover)
														{
															this.state_frame = 0
															this.state = State_Walk
														}
												}
	
	this.StartAttack =  function ()
												{
													/////////////////////////////////////////////////////////////////////////////////////////
												
													end = TalkCheck(this)
													if (end != -1 && IsPlayer(this.name)) 
														{
															//this.EndAttack()
															return Person[end].onTalk(this)
														}
																										
													this.state = State_Attack
												
													var weapon_name = this.name+"_weapon"
													CreatePerson(weapon_name, Weapon[this.weapon].sprite, true)
													
													SetPersonIgnoreList(this.name, [weapon_name])
													
													base = GetPersonBase(this.name)
													
													SetPersonDirection(weapon_name, GetPersonDirection(this.name) )
													
													/////////////////////////////////////////////////////////////////////////////////////////
													
													switch( GetPersonDirection(this.name).toLowerCase() )
														{
															case "north":
																SetPersonX(weapon_name, GetPersonX(this.name) )
																SetPersonY(weapon_name, GetPersonY(this.name)-(base.y2-base.y1+1) )
															break;
															case "south":
																SetPersonX(weapon_name, GetPersonX(this.name) )
																SetPersonY(weapon_name, GetPersonY(this.name)+(base.y2-base.y1+1) )	
															break;														
															case "east":
																SetPersonX(weapon_name, GetPersonX(this.name)+(base.x2-base.x1+1) )
																SetPersonY(weapon_name, GetPersonY(this.name) )
															break;															
															case "west":
																SetPersonX(weapon_name, GetPersonX(this.name)-(base.x2-base.x1+1) )
																SetPersonY(weapon_name, GetPersonY(this.name) )
															break;
															
														}													
													
													/////////////////////////////////////////////////////////////////////////////////////////
													
													IgnorePersonObstructions(weapon_name, true)
													

													
													/////////////////////////////////////////////////////////////////////////////////////////
												}
											
	this.UpdateAttack = function()
												{
												
													/////////////////////////////////////////////////////////////////////////////////////////
													
													var weapon_name = this.name+"_weapon"
													
													SetPersonDirection(weapon_name, GetPersonDirection(this.name) )
													
													QueuePersonCommand(weapon_name,COMMAND_ANIMATE,true)
													
													/////////////////////////////////////////////////////////////////////////////////////////
													
													e = 0;
													
													a = PersonNameToPlayerNumber(this.name)
													
													
													if (a != -1)
														{
															if (Player[a].character == Character_Keli) e = (this.state_frame*2)
														}
													
													switch( GetPersonDirection(this.name).toLowerCase() )
														{
															case "north":
																SetPersonX(weapon_name, GetPersonX(this.name) )
																SetPersonY(weapon_name, GetPersonY(this.name)-(base.y2-base.y1+1)-e )
															break;
															case "south":
																SetPersonX(weapon_name, GetPersonX(this.name) )
																SetPersonY(weapon_name, GetPersonY(this.name)+(base.y2-base.y1+1)+e )	
															break;														
															case "east":
																SetPersonX(weapon_name, GetPersonX(this.name)+(base.x2-base.x1+1)+e )
																SetPersonY(weapon_name, GetPersonY(this.name) )
															break;															
															case "west":
																SetPersonX(weapon_name, GetPersonX(this.name)-(base.x2-base.x1+1)-e )
																SetPersonY(weapon_name, GetPersonY(this.name) )
															break;
															
														}
														
													/////////////////////////////////////////////////////////////////////////////////////////										
												
													CheckAttack(this,weapon_name)
													
													/////////////////////////////////////////////////////////////////////////////////////////	
													
													if (this.state_frame >= Weapon[this.weapon].attack_duration) this.EndAttack();
												
													/////////////////////////////////////////////////////////////////////////////////////////
												
												}
											
											
	this.EndAttack =    function ()
												{
													/////////////////////////////////////////////////////////////////////////////////////////
													
													SetPersonIgnoreList(this.name, [])
												
													this.state = State_Recover;
													this.state_frame = 0
													
													DestroyPerson(this.name+"_weapon")
													
													/////////////////////////////////////////////////////////////////////////////////////////
												}
											
	this.MoveCode = new oMoveCode()
	
	this.brain = new Array()
	
	this.type = Type_Enemy

}

/////////////////////////////////////////////////////////////////////////////////////////

function oPlayer(name,sprite,u,d,l,r,a,b,c,onUpdate) //uuddllrrabab
{

	/////////////////////////////////////////////////////////////////////////////////////////

	this.name = name //PLAYER'S PERSON NAME
	
	/////////////////////////////////////////////////////////////////////////////////////////
	//PLAYER BUTTON DEFINITIONS
	/////////////////////////////////////////////////////////////////////////////////////////

	this.Up = u
	this.Down = d
	this.Left = l
	this.Right = r
	
	this.A = a
	this.B = b
	this.C = c
	
	/////////////////////////////////////////////////////////////////////////////////////////
	
	this.sprite = sprite
	
	this.character = Character_Thomas
	
	this.item = new Array()
	this.weapon = new Array()
	this.armor = new Array()
	
	this.onUpdate = onUpdate //Is ran for every update, used for player controls

}

/////////////////////////////////////////////////////////////////////////////////////////

function CheckAttack(obj, weapon_name)
{

	IgnorePersonObstructions(weapon_name, false)
	
	Obs_Person = GetObstructingPerson(weapon_name, GetPersonX(weapon_name), GetPersonY(weapon_name))
	
	if (Obs_Person != "")
		{
			Obs_Person = PersonNameToNumber(Obs_Person)
			if (Obs_Person != -1) Person[Obs_Person].onHurt(obj);
		}
		
}

/////////////////////////////////////////////////////////////////////////////////////////

function CheckTalkHit(obj, weapon_name)
{

	IgnorePersonObstructions(weapon_name, false)
	
	Obs_Person = GetObstructingPerson(weapon_name, GetPersonX(weapon_name), GetPersonY(weapon_name))
	
	if (Obs_Person != "")
		{
			SetPersonIgnoreList(Obs_Person, [weapon_name])
			Obs_Person = PersonNameToNumber(Obs_Person)
			if (Obs_Person != -1) 
				{
					if (Person[Obs_Person].talk == true) return Obs_Person
					else { return -1 }
				}
		}
		
	return -1	
}

/////////////////////////////////////////////////////////////////////////////////////////

function TalkCheck(obj)
{
	var weapon_name = obj.name+"_weapon"
	CreatePerson(weapon_name, "talk.rss", true)
													
	SetPersonIgnoreList(obj.name, [weapon_name])
													
	base = GetPersonBase(weapon_name)
													
	SetPersonDirection(weapon_name, GetPersonDirection(obj.name) )
													
	/////////////////////////////////////////////////////////////////////////////////////////
													
	switch( GetPersonDirection(obj.name).toLowerCase() )
		{
			case "north":
				SetPersonX(weapon_name, GetPersonX(obj.name) )
				SetPersonY(weapon_name, GetPersonY(obj.name)-(base.y2-base.y1+1) )
			break;
			case "south":
				SetPersonX(weapon_name, GetPersonX(obj.name) )
				SetPersonY(weapon_name, GetPersonY(obj.name)+(base.y2-base.y1+1) )	
			break;														
			case "east":
				SetPersonX(weapon_name, GetPersonX(obj.name)+(base.x2-base.x1+1) )
				SetPersonY(weapon_name, GetPersonY(obj.name) )
			break;															
			case "west":
				SetPersonX(weapon_name, GetPersonX(obj.name)-(base.x2-base.x1+1) )
				SetPersonY(weapon_name, GetPersonY(obj.name) )
			break;						
		}													
													
	/////////////////////////////////////////////////////////////////////////////////////////
													
	//IgnorePersonObstructions(weapon_name, true)
													
	end = CheckTalkHit(obj,weapon_name)
													
	DestroyPerson(obj.name+"_weapon")
													
	return end
}

/////////////////////////////////////////////////////////////////////////////////////////

function Random(lo,hi)
{
	hi++
	var random = lo += Math.floor(Math.random() * (hi - lo));
	return random
}

/////////////////////////////////////////////////////////////////////////////////////////

function FadeToColor(msecs, clr)
{
  var image = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());
  var color = CreateColor(clr.red, clr.green, clr.blue, clr.alpha);

  var time = GetTime();
  while (GetTime() - time < msecs) {
    color.alpha = (GetTime() - time) * 255 / msecs;
    image.blit(0, 0);
    ApplyColorMask(color);
    FlipScreen();
  }

  color.alpha = 255;
  image.blit(0, 0);
  ApplyColorMask(color);
  FlipScreen();

  image.blit(0, 0);
}

/////////////////////////////////////////////////////////////////////////////////////////

function FadeFromColor(msecs, clr)
{
  var image = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());
  var color = CreateColor(clr.red, clr.green, clr.blue, clr.alpha);

  var time = GetTime();
  while (GetTime() - time < msecs)
  {
    color.alpha = 255 - (GetTime() - time) * 255 / msecs;
    image.blit(0, 0);
    ApplyColorMask(color);
    FlipScreen();
  }

  color.alpha = 0;
  image.blit(0, 0);
  ApplyColorMask(color);
  FlipScreen();

  image.blit(0, 0);
}

/////////////////////////////////////////////////////////////////////////////////////////

function PersonExists(name)
{
	list = GetPersonList()
	
	for (var i = 0; i < list.length; i++)
		{
			if (list[i] == name) return true
		}
		
	return false
}

function DoNothing() { } 

var gSoundList = {}
function GetSound(filename) {
  if (!(filename in gSoundList)) {
    gSoundList[filename] = LoadSound(filename);    
  }
  return gSoundList[filename];
}